diff -r f77229934d59 src/org/armedbear/lisp/Pathname.java
--- a/src/org/armedbear/lisp/Pathname.java	Tue Jan 26 12:30:57 2010 +0100
+++ b/src/org/armedbear/lisp/Pathname.java	Tue Jan 26 12:34:38 2010 +0100
@@ -970,230 +1096,272 @@
         }
         return true;
     }
-
     // ### pathnamep
     private static final Primitive PATHNAMEP =
-        new Primitive("pathnamep", "object")
-    {
-        @Override
-        public LispObject execute(LispObject arg)
-        {
-            return arg instanceof Pathname ? T : NIL;
-        }
-    };
+      new Primitive("pathnamep", "object") {
 
+          @Override
+          public LispObject execute(LispObject arg) {
+              return arg instanceof Pathname ? T : NIL;
+          }
+      };
     // ### logical-pathname-p
     private static final Primitive LOGICAL_PATHNAME_P =
-        new Primitive("logical-pathname-p", PACKAGE_SYS, true, "object")
-    {
-        @Override
-        public LispObject execute(LispObject arg)
-        {
-            return arg instanceof LogicalPathname ? T : NIL;
-        }
-    };
+      new Primitive("logical-pathname-p", PACKAGE_SYS, true, "object") {
 
+          @Override
+          public LispObject execute(LispObject arg) {
+              return arg instanceof LogicalPathname ? T : NIL;
+          }
+      };
     // ### user-homedir-pathname &optional host => pathname
     private static final Primitive USER_HOMEDIR_PATHNAME =
-        new Primitive("user-homedir-pathname", "&optional host")
-    {
-        @Override
-        public LispObject execute(LispObject[] args)
-        {
-            switch (args.length) {
-                case 0: {
-                    String s = System.getProperty("user.home");
-                    if (!s.endsWith(File.separator))
-                        s = s.concat(File.separator);
-                    return new Pathname(s);
+      new Primitive("user-homedir-pathname", "&optional host") {
+
+          @Override
+          public LispObject execute(LispObject[] args) {
+              switch (args.length) {
+                  case 0: {
+                      String s = System.getProperty("user.home");
+                      if (!s.endsWith(File.separator)) {
+                          s = s.concat(File.separator);
+                      }
+                      return new Pathname(s);
+                  }
+                  case 1:
+                      return NIL;
+                  default:
+                      return error(new WrongNumberOfArgumentsException(this));
+              }
+          }
+      };
+    // ### list-directory
+    private static final Primitive LIST_DIRECTORY =
+      new Primitive("list-directory", PACKAGE_SYS, true) {
+
+          @Override
+          public LispObject execute(LispObject arg) {
+              Pathname pathname = coerceToPathname(arg);
+              if (pathname instanceof LogicalPathname) {
+                  pathname = LogicalPathname.translateLogicalPathname((LogicalPathname) pathname);
+              }
+              LispObject result = NIL;
+              String s = pathname.getNamestring();
+              if (s != null) {
+                  File f = new File(s);
+                  if (f.isDirectory()) {
+                      try {
+                          File[] files = f.listFiles();
+                          for (int i = files.length; i-- > 0;) {
+                              File file = files[i];
+                              Pathname p;
+                              if (file.isDirectory()) {
+                                  p = Utilities.getDirectoryPathname(file);
+                              } else {
+                                  p = new Pathname(file.getCanonicalPath());
+                              }
+                              result = new Cons(p, result);
+                          }
+                      } catch (IOException e) {
+                          return error(new FileError("Unable to list directory " + pathname.writeToString() + ".",
+                            pathname));
+                      } catch (SecurityException e) {
+                      } catch (NullPointerException e) {
+                      }
+                  }
+              }
+              return result;
+          }
+      };
+
+    public boolean isAbsolute()  {
+        if (!directory.equals(NIL) || !(directory == null)) {
+            if (directory instanceof Cons) {
+                if (((Cons)directory).car().equals(Keyword.ABSOLUTE)) {
+                    return true;
                 }
-                case 1:
-                    return NIL;
-                default:
-                    return error(new WrongNumberOfArgumentsException(this));
             }
         }
-    };
-
-    // ### list-directory
-    private static final Primitive LIST_DIRECTORY =
-        new Primitive("list-directory", PACKAGE_SYS, true)
-    {
-        @Override
-        public LispObject execute(LispObject arg)
-        {
-            Pathname pathname = coerceToPathname(arg);
-            if (pathname instanceof LogicalPathname)
-                pathname = LogicalPathname.translateLogicalPathname((LogicalPathname)pathname);
-            LispObject result = NIL;
-            String s = pathname.getNamestring();
-            if (s != null) {
-                File f = new File(s);
-                if (f.isDirectory()) {
-                    try {
-			File[] files = f.listFiles();
-                        for (int i = files.length; i-- > 0;) {
-                            File file = files[i];
-                            Pathname p;
-                            if (file.isDirectory())
-                                p = Utilities.getDirectoryPathname(file);
-                            else
-                                p = new Pathname(file.getCanonicalPath());
-                            result = new Cons(p, result);
-                        }
-                    }
-                    catch (IOException e) {
-                        return error(new FileError("Unable to list directory " + pathname.writeToString() + ".",
-                                                   pathname));
-                    }
-                    catch (SecurityException e) {
-                    }
-                    catch (NullPointerException e) {
-                    }
-                }
-            }
-            return result;
-        }
-    };
-
-    public boolean isWild()
-    {
-        if (host == Keyword.WILD || host == Keyword.WILD_INFERIORS)
-            return true;
-        if (device == Keyword.WILD || device == Keyword.WILD_INFERIORS)
-            return true;
-        if (directory instanceof Cons) {
-            if (memq(Keyword.WILD, directory))
-                return true;
-            if (memq(Keyword.WILD_INFERIORS, directory))
-                return true;
-        }
-        if (name == Keyword.WILD || name == Keyword.WILD_INFERIORS)
-            return true;
-        if (type == Keyword.WILD || type == Keyword.WILD_INFERIORS)
-            return true;
-        if (version == Keyword.WILD || version == Keyword.WILD_INFERIORS)
-            return true;
         return false;
     }
 
+    public boolean isJar() {
+        if (device instanceof Cons) {
+            return true;
+        }
+        return false;
+    }
+
+    public boolean isWild() {
+        if (host == Keyword.WILD || host == Keyword.WILD_INFERIORS) {
+            return true;
+        }
+        if (device == Keyword.WILD || device == Keyword.WILD_INFERIORS) {
+            return true;
+        }
+        if (directory instanceof Cons) {
+            if (memq(Keyword.WILD, directory)) {
+                return true;
+            }
+            if (memq(Keyword.WILD_INFERIORS, directory)) {
+                return true;
+            }
+        }
+        if (name == Keyword.WILD || name == Keyword.WILD_INFERIORS) {
+            return true;
+        }
+        if (type == Keyword.WILD || type == Keyword.WILD_INFERIORS) {
+            return true;
+        }
+        if (version == Keyword.WILD || version == Keyword.WILD_INFERIORS) {
+            return true;
+        }
+        return false;
+    }
     // ### %wild-pathname-p
     private static final Primitive _WILD_PATHNAME_P =
-        new Primitive("%wild-pathname-p", PACKAGE_SYS, true)
-    {
-        @Override
-        public LispObject execute(LispObject first, LispObject second)
+      new Primitive("%wild-pathname-p", PACKAGE_SYS, true) {
 
-        {
-            Pathname pathname = coerceToPathname(first);
-            if (second == NIL)
-                return pathname.isWild() ? T : NIL;
-            if (second == Keyword.DIRECTORY) {
-                if (pathname.directory instanceof Cons) {
-                    if (memq(Keyword.WILD, pathname.directory))
-                        return T;
-                    if (memq(Keyword.WILD_INFERIORS, pathname.directory))
-                        return T;
-                }
-                return NIL;
-            }
-            LispObject value;
-            if (second == Keyword.HOST)
-                value = pathname.host;
-            else if (second == Keyword.DEVICE)
-                value = pathname.device;
-            else if (second == Keyword.NAME)
-                value = pathname.name;
-            else if (second == Keyword.TYPE)
-                value = pathname.type;
-            else if (second == Keyword.VERSION)
-                value = pathname.version;
-            else
-                return error(new ProgramError("Unrecognized keyword " +
-                                              second.writeToString() + "."));
-            if (value == Keyword.WILD || value == Keyword.WILD_INFERIORS)
-                return T;
-            else
-                return NIL;
-        }
-    };
-
+          @Override
+          public LispObject execute(LispObject first, LispObject second) {
+              Pathname pathname = coerceToPathname(first);
+              if (second == NIL) {
+                  return pathname.isWild() ? T : NIL;
+              }
+              if (second == Keyword.DIRECTORY) {
+                  if (pathname.directory instanceof Cons) {
+                      if (memq(Keyword.WILD, pathname.directory)) {
+                          return T;
+                      }
+                      if (memq(Keyword.WILD_INFERIORS, pathname.directory)) {
+                          return T;
+                      }
+                  }
+                  return NIL;
+              }
+              LispObject value;
+              if (second == Keyword.HOST) {
+                  value = pathname.host;
+              } else if (second == Keyword.DEVICE) {
+                  value = pathname.device;
+              } else if (second == Keyword.NAME) {
+                  value = pathname.name;
+              } else if (second == Keyword.TYPE) {
+                  value = pathname.type;
+              } else if (second == Keyword.VERSION) {
+                  value = pathname.version;
+              } else {
+                  return error(new ProgramError("Unrecognized keyword "
+                    + second.writeToString() + "."));
+              }
+              if (value == Keyword.WILD || value == Keyword.WILD_INFERIORS) {
+                  return T;
+              } else {
+                  return NIL;
+              }
+          }
+      };
     // ### merge-pathnames
     private static final Primitive MERGE_PATHNAMES =
-        new Primitive("merge-pathnames",
-                      "pathname &optional default-pathname default-version")
-    {
-        @Override
-        public LispObject execute(LispObject arg)
-        {
-            Pathname pathname = coerceToPathname(arg);
-            Pathname defaultPathname =
+      new Primitive("merge-pathnames",
+      "pathname &optional default-pathname default-version") {
+
+          @Override
+          public LispObject execute(LispObject arg) {
+              Pathname pathname = coerceToPathname(arg);
+              Pathname defaultPathname =
                 coerceToPathname(Symbol.DEFAULT_PATHNAME_DEFAULTS.symbolValue());
-            LispObject defaultVersion = Keyword.NEWEST;
-            return mergePathnames(pathname, defaultPathname, defaultVersion);
-        }
-        @Override
-        public LispObject execute(LispObject first, LispObject second)
+              LispObject defaultVersion = Keyword.NEWEST;
+              return mergePathnames(pathname, defaultPathname, defaultVersion);
+          }
 
-        {
-            Pathname pathname = coerceToPathname(first);
-            Pathname defaultPathname =
+          @Override
+          public LispObject execute(LispObject first, LispObject second) {
+              Pathname pathname = coerceToPathname(first);
+              Pathname defaultPathname =
                 coerceToPathname(second);
-            LispObject defaultVersion = Keyword.NEWEST;
-            return mergePathnames(pathname, defaultPathname, defaultVersion);
-        }
-        @Override
-        public LispObject execute(LispObject first, LispObject second,
-                                  LispObject third)
+              LispObject defaultVersion = Keyword.NEWEST;
+              return mergePathnames(pathname, defaultPathname, defaultVersion);
+          }
 
-        {
-            Pathname pathname = coerceToPathname(first);
-            Pathname defaultPathname =
+          @Override
+          public LispObject execute(LispObject first, LispObject second,
+            LispObject third) {
+              Pathname pathname = coerceToPathname(first);
+              Pathname defaultPathname =
                 coerceToPathname(second);
-            LispObject defaultVersion = third;
-            return mergePathnames(pathname, defaultPathname, defaultVersion);
-        }
-    };
+              LispObject defaultVersion = third;
+              return mergePathnames(pathname, defaultPathname, defaultVersion);
+          }
+      };
+
+    public static final Pathname mergePathnames(Pathname pathname, Pathname defaultPathname) {
+        return mergePathnames(pathname, defaultPathname, Keyword.NEWEST);
+    }
 
     public static final Pathname mergePathnames(Pathname pathname,
                                                 Pathname defaultPathname,
-                                                LispObject defaultVersion)
-
+                                                LispObject defaultVersion) 
     {
         Pathname p;
-        if (pathname instanceof LogicalPathname)
+        if (pathname instanceof LogicalPathname) {
             p = new LogicalPathname();
-        else {
+        } else {
             p = new Pathname();
-            if (defaultPathname instanceof LogicalPathname)
-                defaultPathname = LogicalPathname.translateLogicalPathname((LogicalPathname)defaultPathname);
+            if (defaultPathname instanceof LogicalPathname) {
+                defaultPathname 
+                    = LogicalPathname.translateLogicalPathname((LogicalPathname) defaultPathname);
+            }
         }
-        if (pathname.host != NIL)
+        if (pathname.host != NIL) {
             p.host = pathname.host;
-        else
+        } else {
             p.host = defaultPathname.host;
-        if (pathname.device != NIL)
+        }
+        if (pathname.device != NIL) {
             p.device = pathname.device;
-        else
+        } else {
             p.device = defaultPathname.device;
-        p.directory =
-            mergeDirectories(pathname.directory, defaultPathname.directory);
-        if (pathname.name != NIL)
+        }
+        // Merging with a JAR always produces relative directories
+        if (defaultPathname.device instanceof Cons  
+            && pathname.directory instanceof Cons
+            && pathname.directory.car().equals(Keyword.ABSOLUTE)) {
+            if (pathname.directory.cdr().equals(NIL)) {
+                pathname.directory = NIL;
+            } else {
+                ((Cons)pathname.directory).car = Keyword.RELATIVE;
+            }
+        }
+
+        if (pathname.isJar()) {
+            if (pathname.device.car() instanceof Pathname) {
+                Pathname first = mergePathnames((Pathname)pathname.device.car(), defaultPathname);
+                p.device = new Cons(first, pathname.device.cdr());
+            }
+        } else {
+            p.directory = mergeDirectories(pathname.directory, defaultPathname.directory);
+        }
+
+        if (pathname.name != NIL) {
             p.name = pathname.name;
-        else
+        } else {
             p.name = defaultPathname.name;
-        if (pathname.type != NIL)
+        }
+        if (pathname.type != NIL) {
             p.type = pathname.type;
-        else
+        } else {
             p.type = defaultPathname.type;
-        if (pathname.version != NIL)
+        }
+        if (pathname.version != NIL) {
             p.version = pathname.version;
-        else if (pathname.name instanceof AbstractString)
+        } else if (pathname.name instanceof AbstractString) {
             p.version = defaultVersion;
-        else if (defaultPathname.version != NIL)
+        } else if (defaultPathname.version != NIL) {
             p.version = defaultPathname.version;
-        else
+        } else {
             p.version = defaultVersion;
+        }
         if (p instanceof LogicalPathname) {
             // When we're returning a logical
             p.device = Keyword.UNSPECIFIC;
@@ -1202,27 +1370,29 @@
                 LispObject canonical = NIL;
                 while (original != NIL) {
                     LispObject component = original.car();
-                    if (component instanceof AbstractString)
-                        component = LogicalPathname.canonicalizeStringComponent((AbstractString)component);
+                    if (component instanceof AbstractString) {
+                        component = LogicalPathname.canonicalizeStringComponent((AbstractString) component);
+                    }
                     canonical = canonical.push(component);
                     original = original.cdr();
                 }
                 p.directory = canonical.nreverse();
             }
-            if (p.name instanceof AbstractString)
-                p.name = LogicalPathname.canonicalizeStringComponent((AbstractString)p.name);
-            if (p.type instanceof AbstractString)
-                p.type = LogicalPathname.canonicalizeStringComponent((AbstractString)p.type);
+            if (p.name instanceof AbstractString) {
+                p.name = LogicalPathname.canonicalizeStringComponent((AbstractString) p.name);
+            }
+            if (p.type instanceof AbstractString) {
+                p.type = LogicalPathname.canonicalizeStringComponent((AbstractString) p.type);
+            }
         }
         return p;
     }
 
     private static final LispObject mergeDirectories(LispObject dir,
-                                                     LispObject defaultDir)
-
-    {
-        if (dir == NIL)
+                                                     LispObject defaultDir) {
+        if (dir == NIL) {
             return defaultDir;
+        }
         if (dir.car() == Keyword.RELATIVE && defaultDir != NIL) {
             LispObject result = NIL;
             while (defaultDir != NIL) {
